import sys,os
from paraview.simple import *

args = {
	'base':'/tmp/aggregs',
	'out':'heteroGeomEll.png',
}

def readCommandLineParams(args=None):
	if args is None: args = {}
	for i,a in enumerate(sys.argv):
		for k in ('base','out'):
			if a=='--%s'%k:
				args[k] = sys.argv[i+1]
				break
	return args
args = readCommandLineParams()

view = GetRenderView()
view.Background=(1,1,1)
view.OrientationAxesVisibility = 0
view.CenterAxesVisibility = 0
if 1:
	view.ViewSize = [900,900]
	view.CameraFocalPoint = [25e-3 for _ in (0,1,2)]
	view.CameraPosition = (.015,.01,.035)
	view.CameraViewUp = (0,0,1)

for i in (0,1):
	data = OpenDataFile('%s%d.vtk'%(args['base'],i))
	normals = GenerateSurfaceNormals(data,FeatureAngle=90)
	rep = GetDisplayProperties(normals)
	if i==0:
		rep.LookupTable = MakeBlueToRedLT(.5e-3,16e-3)
		rep.ColorAttributeType = 'POINT_DATA'
		rep.ColorArrayName = 'size'
	else:
		rep.DiffuseColor = [0,1,1]
		rep.Opacity = .1
	Show(normals)

Render()
WriteImage(args['out'])

