from aggregpacking import *

def createDatFile(base,randomizer,heterogeom):
	r = randomizer
	f = open(base+'-theor.dat','w')
	if isinstance(r,ExperimentalSieveCurveRandomizer):
		f.writelines('%g %g\n'%(s,v) for s,v in r.values)
	elif isinstance(r,FullerCurveRandomizer):
		s = r.minSize
		while s<r.maxSize:
			f.write('%g %g\n'%(s,r.cdf(s)))
			s *= 1.1
		s = r.maxSize
		f.write('%g %g\n'%(s,r.cdf(s)))
	f.close()
	#
	vol = sum(a.volume for a in heterogeom.aggregates)
	vol /= (1.-r.cdf(r.minSize))
	mi,ma,d = r.minSize,r.maxSize,2**(1/2**4.)
	x = mi
	xs = []
	while x <= 1.1*ma:
		xs.append(x)
		x *= d
	ys = [r.cdf(mi)+sum(a.volume for a in heterogeom.aggregates if a.size < x)/vol for x in xs]
	f = open(base+'.dat','w')
	f.write('# size cumAmount\n')
	f.writelines(['%g %g\n'%(x,y) for x,y in zip(xs,ys)])
	f.close()	

def gnuplot(outName,datActual,datTheor,gpiName='/tmp/gpi.gpi'):
	lines = [
		'set term png 15',
		'set grid',
		'set border 3',
		'set tics nomirror',
		'set key bottom',
		'set log x',
		'set xtics (1,2,4,8,16)',
		'set xr [1:16]',
		'set yr [0:1]',
		'set xlabel "Aggregate size [mm]"',
		'set ylabel "Relative cumulative mass [-]"',
		'set output "%s"'%outName,
		'lww=3',
		'plot "%s" u (1000*$1):2 w l lw lww t "theoretical sieve curve", "%s" u (1000*$1):2 w l lw lww t "numerical sieve curve"'%(datTheor,datActual),
	]
	f = open(gpiName,'w')
	f.writelines(line+'\n' for line in lines)
	f.close()
	import subprocess
	subprocess.Popen(['gnuplot',gpiName]).wait()
