from paraview.simple import *
import sys

args = {
	'sph':'/tmp/aggregs.vtk',
	'sec':'/tmp/aggregsSection.vtk',
	'out':'heteroGeom.png',
}

def readCommandLineParams(args=None):
	for i,a in enumerate(sys.argv):
		for k in ('sph','sec','out'):
			if a=='--%s'%k:
				args[k] = sys.argv[i+1]
				break
	return args

readCommandLineParams(args)
sph,sec = args['sph'],args['sec']

view = GetRenderView()
view.Background=(1,1,1)
view.OrientationAxesVisibility = 0
view.CenterAxesVisibility = 0
view.ViewSize = [900,900]
view.CameraFocalPoint = [25e-3 for _ in (0,1,2)]
view.CameraPosition = (.015,.01,.035)
view.CameraViewUp = (0,0,1)

if 1:
	sphData = OpenDataFile(sph)
	spheres = Glyph(sphData,GlyphType='Sphere',SetScaleFactor=1.,MaskPoints=0,ScaleMode='scalar',Scalars='radius')
	spheres.GlyphType.Radius = 1.
	#
	spheresClip = Clip(spheres)
	spheresClip.ClipType = "Plane"
	spheresClip.ClipType.Origin = [25e-3 for _ in (0,1,2)]
	spheresClip.ClipType.Normal = [1,0,0]
	rep = GetDisplayProperties(spheresClip)
	rep.LookupTable = MakeBlueToRedLT(.25e-3,8e-3)
	rep.ColorAttributeType = 'POINT_DATA'
	rep.ColorArrayName = 'radius'
	#
	spheresClip2 = Clip(spheres)
	spheresClip2.ClipType = "Plane"
	spheresClip2.ClipType.Origin = [25e-3 for _ in (0,1,2)]
	spheresClip2.ClipType.Normal = [-1,0,0]
	rep = GetDisplayProperties(spheresClip2)
	rep.DiffuseColor = [0,1,1]
	rep.Opacity = .1
	#
	Hide(spheres)

if 1:
	secData = OpenDataFile(sec)
	sections = Glyph(secData,GlyphType='Cylinder',SetScaleFactor=1.,MaskPoints=0,ScaleMode='scalar',Scalars='radius',Vectors='normal')
	sections.GlyphTransform.Rotate = [0.,0.,-90.]
	t = sections.GlyphType
	t.Height = .0001
	t.Radius = 1.
	t.Resolution = 64
	rep = GetDisplayProperties(sections)
	rep.LookupTable = MakeBlueToRedLT(.25e-3,8e-3)
	rep.ColorAttributeType = 'POINT_DATA'
	rep.ColorArrayName = 'radius'

Render()
WriteImage(args['out'])
