######################################################################
#
# Basic graphics extension
#
######################################################################

def HGplot1(self):
	from mayavi import mlab
	aggregs = self.aggregates
	mlab.points3d([a.pos.x for a in aggregs],[a.pos.y for a in aggregs],[a.pos.z for a in aggregs],[a.radius for a in aggregs],scale_factor=2.)
	c = self.cubeSize
	mlab.points3d([.5*c],[.5*c],[.5*c],scale_factor=c,mode='cube',color=(0,1,1),opacity=.5)
	mlab.show()

def HGplot2(self,minSize=.5e-3,maxSize=16e-3):
	import pylab
	ds = [2*a.radius for a in aggregs]
	ni = 50
	dSize = pow(maxSize/minSize,1./ni)
	xs = [minSize*pow(dSize,i) for i in xrange(ni+1)]
	c = pow(minSize/maxSize,.5)
	v = sum(d*d*d for d in ds)
	print 'volume',v
	k = (1-c)/v
	ys = [c+sum([d*d*d*k for d in ds if d<x]) for x in xs]
	ys2 = [pow(x/maxSize,.5) for x in xs]
	ys2 = [y/float(ys2[-1]) for y in ys2]
	import pylab
	pylab.plot(xs,ys)
	pylab.plot(xs,ys2)
	pylab.xscale('log')
	pylab.xlim([minSize,maxSize])
	pylab.ylim([0,1])
	pylab.show()
	if 1:
		f = open('sievecurve.dat','w')
		f.write('# size P_theor P_numerical\n')
		for xyy2 in zip(xs,ys,ys2):
			f.write('%e %e %e\n'%xyy2)
		f.close()

def octreePlot(self,showGrid=True,showData=True,onlyLevel=-1):
	from mayavi import mlab
	from numpy import zeros,array
	if showGrid:
		l = [ch for ch in self if onlyLevel<0 or ch.level==onlyLevel]
		n = len(l)
		x,y,z,s = zeros(n),zeros(n),zeros(n),zeros(n)
		for i,node in enumerate(l):
			c = node.center
			x[i] = c.x
			y[i] = c.y
			z[i] = c.z
			s[i] = node.size
		pts = mlab.points3d(x,y,z,s,color=(0,1,0),mode='cube',scale_factor=1.)
		pts.actor.property.representation = 'wireframe'
	if showData:
		l = [d for ch in self for d in ch.data if onlyLevel<0 or ch.level==onlyLevel]
		n = len(l)
		x,y,z,s = zeros(n),zeros(n),zeros(n),zeros(n)
		for i,d in enumerate(l):
			c = d.pos
			x[i] = c.x
			y[i] = c.y
			z[i] = c.z
			s[i] = d.size
		pts = mlab.points3d(x,y,z,s,color=(1,0,0),mode='cube',scale_factor=1.)
		pts.actor.property.representation = 'wireframe'
	mlab.show()

