/*
*
*      AggregPacking : Generator of random aggregate packings in concrete     
*                                                                             
*                           version 0.1 (2014-08-22)                          
* 
*                      Copyright (C)  2014  Jan Stransky                      
* 
*          Czech Technical University, Faculty of Civil Engineering,          
*      Department of Structural Mechanics, 166 29 Prague, Czech Republic      
* 
* AggregPacking is free software: you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as published by the
* Free Software Foundation, either version 3 of the License, or (at your
* option) any later version.
* 
* AggregPacking is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
* for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#include "utils.hpp"

#ifdef AGGREGPACKING_SERIALIZATION
#include <iomanip>
#endif

namespace aggregpacking {

/**********************************************************************
* FILES
**********************************************************************/
#ifdef AGGREGPACKING_SERIALIZATION
bool
initFile(ofstream& f, const string& fName, const string& fileName) {
	if (fName.size()==0 && fileName.size()==0) return false;
	const string fff = fName.size()==0 ? fileName : fName;
	f.open(fff);
	f << std::setprecision(10); // TODO?
	return f.is_open();
}

bool
initFile(ifstream& f, const string& fName, const string& fileName) {
	if (fName.size()==0 && fileName.size()==0) return false;
	const string fff = fName.size()==0 ? fileName : fName;
	f.open(fff);
	return f.is_open();
}
#endif

} // namespace
